"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License.
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFabricComponents = void 0;
var AC = require("adaptivecards");
var react_1 = require("@fluentui/react");
var Components = require(".");
var Actions = require("../actions");
var iconsInitialized = false;
exports.useFabricComponents = function () {
    if (!iconsInitialized) {
        react_1.initializeIcons();
        iconsInitialized = true;
    }
    // add component extensions
    AC.AdaptiveCard.elementTypeRegistry.registerType("Input.Date", function () { return new Components.InputDateFabric(); });
    AC.AdaptiveCard.elementTypeRegistry.registerType("Input.Text", function () { return new Components.InputTextFabric(); });
    AC.AdaptiveCard.elementTypeRegistry.registerType("Input.Time", function () { return new Components.InputTimeFabric(); });
    AC.AdaptiveCard.elementTypeRegistry.registerType("Input.Number", function () { return new Components.InputNumberFabric(); });
    AC.AdaptiveCard.elementTypeRegistry.registerType("Input.Toggle", function () { return new Components.InputToggleFabric(); });
    AC.AdaptiveCard.elementTypeRegistry.registerType("Input.ChoiceSet", function () { return new Components.InputChoiceSetFabric(); });
    // add actions extensions
    AC.AdaptiveCard.actionTypeRegistry.registerType("Action.OpenUrl", function () { return new Actions.OpenUrlActionFabric(); });
    AC.AdaptiveCard.actionTypeRegistry.registerType("Action.Submit", function () { return new Actions.SubmitActionFabric(); });
    AC.AdaptiveCard.actionTypeRegistry.registerType("Action.ShowCard", function () { return new Actions.ShowCardActionFabric(); });
    AC.AdaptiveCard.actionTypeRegistry.registerType("Action.ToggleVisibility", function () { return new Actions.ToggleVisibilityActionFabric(); });
};
//# sourceMappingURL=Fabric.js.map