"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputNumberFabric = void 0;
var React = require("react");
var AC = require("adaptivecards");
var FabricUI = require("@fluentui/react");
var Shared = require("../../utils/shared");
var InputNumberFabric = /** @class */ (function (_super) {
    __extends(InputNumberFabric, _super);
    function InputNumberFabric() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.parse = function (json, errors) {
            _super.prototype.parse.call(_this, json, errors);
            _this.value = _this.defaultValue;
            _this.min = Shared.getIntValue(json.min);
            _this.max = Shared.getIntValue(json.max);
            _this.placeholder = AC.getStringValue(json.placeholder);
        };
        _this.renderReact = function () { return (React.createElement(FabricUI.TextField, { id: _this.id, placeholder: "" + _this.placeholder, value: "" + _this.defaultValue, type: "number", max: _this.max, min: _this.min, onChange: _this.handleChange })); };
        _this.getJsonTypeName = function () { return "Input.Number"; };
        _this.toJSON = function () {
            var result = _super.prototype.toJSON.call(_this);
            AC.setProperty(result, "placeholder", _this.placeholder);
            AC.setProperty(result, "min", _this.min);
            AC.setProperty(result, "max", _this.max);
            return result;
        };
        return _this;
    }
    return InputNumberFabric;
}(Shared.ReactInputElement));
exports.InputNumberFabric = InputNumberFabric;
//# sourceMappingURL=InputNumberFabric.js.map