import * as React from "react";
import * as AC from "adaptivecards";
export declare const getDiv: () => HTMLDivElement;
export declare abstract class ReactCardElement extends AC.CardElement {
    protected abstract renderReact(): JSX.Element;
    protected internalRender(): HTMLElement;
}
export declare abstract class ReactCardElementContainer extends AC.Container {
    protected abstract renderReact(): JSX.Element;
    protected internalRender(): HTMLElement;
}
export declare abstract class ReactInputElement extends AC.Input {
    private _value;
    private _inlineAction;
    protected abstract renderReact(): JSX.Element;
    protected internalRender(): HTMLElement;
    protected overrideInternalRender(): HTMLElement;
    protected handleChange: (event: React.FormEvent<HTMLInputElement | HTMLTextAreaElement>, newValue?: string) => void;
    get value(): string;
    set value(value: string);
    get inlineAction(): AC.Action;
    set inlineAction(action: AC.Action);
    private buildInlineActionButton;
    private inlineActionClickHandler;
    private inlineIconActionButton;
    private buildTextOnlyInlineActionActionButton;
}
export declare const raiseParseError: (error: AC.IValidationError, errors: Array<AC.IValidationError>) => void;
export declare const getIntValue: (val: any, errors?: AC.IValidationError[], defaultValue?: number) => number;
